/* eslint class-methods-use-this: 0 */

const _ = require('lodash');
const auditDal = require('./audit.dal');
const queryBuilder = require('./audit.query');

class Audit {
    store(auditData) {
        const audit = {
            accountId: _.get(auditData, 'metainfo.accountId'),
            userId: _.get(auditData, 'metainfo.userId'),
            entity: _.get(auditData, 'metainfo.entity'),
            entityId: _.get(auditData, 'metainfo.entityId'),
            action: _.get(auditData, 'metainfo.action'),
            req_url: _.get(auditData, 'request.url'),
            req_body: JSON.stringify(_.get(auditData, 'request.body')),
            req_query: JSON.stringify(_.get(auditData, 'request.query')),
            req_params: JSON.stringify(_.get(auditData, 'request.params')),
            rs_status: _.get(auditData, 'response.status'),
            createdAt: new Date()
        };
        return auditDal.store(audit);
    }

    getAudit({ accountId, qs }) {
        return auditDal.getAudit(queryBuilder.buildQuery(qs, accountId));
    }

}

module.exports = new Audit();
